#include<bits/stdc++.h>
using namespace std;
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long n,m,p,k=0,sb=0,br=0;
    cin>>m>>n>>p;
    int s=n;
    int v=n;
    p--;
    pair<int,int>b[4]={{0,1},{1,0},{0,-1},{-1,0}};
    int x=0,y=0,nx=0,ny=0;
    while (true){
        if (x==p){
            sb+=m;
            br++;
            if (br==v){
                break;
            }
        }
        m++;
        if (b[k].first+x>=n||b[k].first+x<nx||b[k].second+y>=s||b[k].second+y<ny){
        if (k==0){
            nx++;
        }
        if (k==1){
            s--;
        }
        if (k==2){
            n--;
        }
        if (k==3){
            ny++;
        }
            k=(k+1)%4;
        }
        x+=b[k].first;
        y+=b[k].second;
    }
    cout<<sb;
    return 0;
}


